#!/bin/sh
cat <<CEND
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <title>Tablica informacyjna</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
        <script type="text/javascript" src="../script.js"></script>
        <script type="text/javascript" src="../languages.js"></script>
        <link rel="stylesheet" type="text/css" href="../tomato.css"/>
CEND
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"/`nvram get web_css`.css\"/>"
cat << CEND
        <style type="text/css">
            textarea {
                width: 80%;
                height: 120px;
                text-align: left;
            }
        </style>
        <script type="text/javascript">
            function validate(){
                var from = fixPort(E("portFrom").value);
                var to = fixPort(E("portTo").value);
                if ((from != -1 && to != -1) && (from <= to)) {
                    var conf = new Array();
                    opts = document.getElementsByName("source");
                    for (i = 0; i < opts.length; i++) {
                        if (opts[i].checked) {
                            conf["source"] = opts[i].value;
                            break;
                        }
                    }
					var index = E("lang").selectedIndex;					
                    conf["lang"] = E("lang").options[index].value;
                    conf["userPass"] = E("userPass").value;
                    conf["range"] = E("portFrom").value + ":" + E("portTo").value
                    conf["message"] = E("message").value;//.value.replace(/;/g, ",").replace(/\r\n/g," ");
					conf["info"] = E("info").value;//.value.replace(/;/g, ",").replace(/\r\n/g," ");
                    E("saveButton").disabled = "disabled";
					disableElement("saveButton");
     				 saveConfiguration(conf);
                }
                else {
                    E("portFrom").className = 'error error-focused';
                    E("portTo").className = 'error error-focused';
                    alert(dict[lang]["portRangeError"]);
                }
                
            }
			/*function show(){
				var winopts = "dependent=yes,toolbar=no,resizable=yes,width=800,height=600";
				var win = window.open(this.href,'_blank',winopts);
				preview(win,E("message").value.replace(/,/g, ";"));
			}*/
        </script>
    </head>
    <body onload="initConf();">
        <table id="container" cellspacing="0">
            <tbody>
                <tr>
				<td id="header" colspan="2">
					<div class="title" id="newsBoardTitle">Tablica ogłoszeń</div>
					<div class="version" id="version">Version 0.3 &alpha;</div>
				</td>
			</tr>
        <tr id="body">
        	<td id="navi">
				<a href="index.sh" class="indent1" id="newsBoard">Tablica&nbsp;ogłoszeń</a>
				<!--<a href="nyi.html" class="indent1">Statystyki</a>-->
                <a href="settings.sh" class="indent1 active" id="settings">Ustawienia</a>
                <a href="stats.sh" class="indent1" id="settings">Statystyki</a>
		<a href="/" class="indent1" id="tomato">Tomato...</a> 
		<a href="about.sh" class="indent1" id="about">O&nbsp;mnie</a> 
            </td>
                    <td id="content">
                        <div id="ident">Tablica ogłoszeń</div>
                        <div class="section-title" id="settingsTitle">
                            Ustawienia
                        </div>
                        <div class="section">
                            <table class="fields" cellpadding="5" cellspacing="5">
                                <tr>
                                    <td class="title indent1" id="language">
                                        Język
                                    </td>
                                    <td class="content">
                                        <select id="lang">
                                        </select>
                                    </td>
                                </tr>
								<tr>
                                    <td class="title indent1" id="source">
                                        Źródło danych
                                    </td>
                                    <td class="content">
                                        <input type="radio" name="source" value="hosts.dnsmasq" /><span id="dhcp">DHCP</span>
                                        <input type="radio" name="source" value="users" /><span id="usersFile" >Plik users</span>
                                        <input type="radio" name="source" value="online" /><span id="onlineUsers">Użytkownicy on-line</span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="title indent1" id="portRange">
                                        Zakres portów
                                    </td>
                                    <td class="content">
                                        <input type="text" id="portFrom" size="5" maxlength="5"/><span>- </span>
                                        <input type="text" id="portTo" size="5" maxlength="5"/>
                                    </td>
                                </tr>
                                <tr style="display:none">
                                    <td class="title indent1" >
                                        <span id="userPasswd">Użytkownik i hasło</span> (<a href="http://home.flash.net/cgi-bin/pw.pl" target="_blank" id="generatePass">wygeneruj wpis</a>)
                                    </td>
                                    <td class="content">
                                        <input type="text" id="userPass" size="25" />
                                    </td>
                                </tr>
                                <tr>
                                    <td class="title indent1">
                                        <span id="commonInfo">Wspólna blokada</span> <br/>
										<input type="button" name="preview" value="Podgląd" onclick="show('info')"/>
                                    </td>
                                    <td class="content">
                                        <textarea id="info">
                                        </textarea>
                                    </td>
                                </tr>
								<tr>
                                    <td class="title indent1">
                                        <span id="commonMsg">Wspólny komunikat</span> <br/>
										<input type="button" name="preview" value="Podgląd" onclick="show('message')"/>
                                    </td>
                                    <td class="content">
                                        <textarea id="message">
                                        </textarea>
                                    </td>
                                </tr>
                            </table>
                            <input type="button" value="Zapisz" name="save" onclick="validate()" id="saveButton"/>
                        </div>
                        <div id="messages">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td id="footer" colspan="2">
                        <span id="footer-msg"/>
                    </td>
                </tr>
            </tbody>
        </table>
    </body>
</html>
CEND
