#!/bin/sh
wdm="/var/wwwext/board/"
hosts="hosts.dnsmasq"
users="users"
echo "" > /tmp/error
if [ $# = 1 ]; then
	source="$1"
else
	source="$(grep "^source=" $wdm.conf | cut -d = -f 2  2>>/tmp/error)"
fi
if [ "$source" == "$hosts" ]; then
	l=$(wc -l < /etc/hosts.dnsmasq  2>>/tmp/error)
	i=2
elif [ "$source" == "$users" ]; then
	l=$(wc -l < $wdm./users  2>>/tmp/error)
	i=1
else
	l=$(wc -l < /proc/net/arp  2>>/tmp/error)
	i=2
fi	
json="{ [";
while [ $i -le $l ];
do
	if [ "$source" == "$hosts" ]; then
		line=$(sed -n $i' p' < /etc/hosts.dnsmasq  2>>/tmp/error)
		ip=$(echo $line | cut -d ' ' -f 1  2>>/tmp/error)
		mac=$(sed "/,$ip,/!dq"  /etc/dnsmasq.conf  | cut -d , -f 1 | sed -n '/dhcp-host=/ s/dhcp-host=//gp'  2>>/tmp/error)
		name=${line#* }
	elif [ "$source" == "$users" ]; then
		line=$(sed -n $i' p' < $wdm./users  2>>/tmp/error);
		mac=${line% *}
		ip=$(fgrep -i $mac /proc/net/arp | cut -d ' ' -f 1  2>>/tmp/error)
		name=${line#* }
	else		
		line="$(sed -n $i' p'  /proc/net/arp  2>>/tmp/error)"
		ip=$(echo "$line" | sed -e 's/ \+/ /g' | cut -d ' ' -f 1  2>>/tmp/error)
		mac=$(echo "$line" | sed -e 's/ \+/ /g' | cut -d ' ' -f 4  2>>/tmp/error)
		device=$(echo "$line" | sed -e 's/ \+/ /g' | cut -d ' ' -f 6  2>>/tmp/error)
		if [ "$device" != "br0" ]; then
	           let "i=$i + 1"
		   continue
		fi;
		name=$(fgrep -i $ip /var/lib/misc/dnsmasq.leases | cut -d ' ' -f 4  2>>/tmp/error)
	fi;
	
	if [ -n "$ip" ]; then
		if [ -z "$(fgrep -i "$ip" /proc/net/arp  2>>/tmp/error)" ]; then online=false; else online=true; fi;
		dhcpName=$(fgrep -i "$ip" /var/lib/misc/dnsmasq.leases | cut -d ' ' -f 4  2>>/tmp/error)
	else
		online=false;
		dhcpName="";
	fi	;		
	macdot=$(echo "$mac" | sed -e '/:/ s/:/./g'  2>>/tmp/error)
	if [ -z "$(fgrep -i "$mac" $wdm./blocked.sh  2>>/tmp/error)" ]; then blocked=false; else blocked=true; fi;
	if [ -z "$(fgrep -i "$mac" $wdm./messages.sh  2>>/tmp/error)" ]; then  delivered=true; else delivered=false; fi;
	json=${json}"{ \"ip\" : "\"${ip}"\", \"mac\" : \""${mac}"\", \"online\" : "${online}", \"name\" : \""${name}"\", \"dhcpName\" : \""${dhcpName}"\", \"blocked\": "${blocked}", \"delivered\" : "${delivered}"} ";
	if [ $i != $l ]; then
		json=${json}",";
	fi
	let "i=$i + 1"
done;
json=${json}"]}";
$wdm./cherr.sh "$json"
