var callbackMethod;
var lang="";
var users;
var editorOn = false;
var sort = ["sortasc","",""];
var url = "board.sh"
var timer;
var timerRunning = false;
var disabledElements = new Array();
User.prototype.generateTableRow = generateTableRow;
User.prototype.equals = function(v){ return cmpMac(this,v)==0; };
User.prototype.toString = function() {
   return 'mac='+this.mac.toUpperCase()+'&name='+this.name+
   '&info='+(isEmpty(this.infoText) ? '' : escape(this.infoText.replace(/;/g, ",").replace(/\r\n/g," ")))+
   '&msg='+(isEmpty(this.msgText) ? '' : escape(this.msgText.replace(/;/g, ",").replace(/\r\n/g," ")))+'&isown='+this.isOwnMsg; 
}
Array.prototype.find = function(v) {
    for (var i = 0; i < this.length; ++i)
        if (this[i].equals(v)) return i;
    return -1;
}
Array.prototype.remove = function(v) {
    var index = this.find(v);
    if (index >= 0) {
        this.splice(index, 1);
        return true;
    }
    return false;
}
String.prototype.isEmpty = function(){
	return isEmpty(this);
}
function User(name, ip, mac, blocked, delivered, online, isOwnMsg, infoText, msgText)
{
    this.name = name;
    this.ip = ip;
    this.mac = mac;
    this.blocked = blocked;
    this.delivered = delivered;
    this.online = online;
    this.isOwnMsg = isOwnMsg;
    this.infoText = infoText;
    this.msgText = msgText;
    this.selected = false;
	this.hasPages = false;
}
function exampleUser(mac){
	return new User(null,null,mac,null,null,null,null,null,null);
}
function getUsers(response){
	response = unescape(response);
	response = jsmin(response);
	var t = eval(response);
	users = new Array();
	for (var i = 0; i < t.length; i++) {
		users[i] = getUser(t[i]);
	}
	setCookie("users", response, null);
    users.sort(cmpMac);
    generateUserGrid();
	if(timerRunning){
		startTimer();
	}
}
function init() {
	lang = isEmpty(getCookie("lang")) ? "pl" : getCookie("lang");
	translate();
    if (hasChanged()) {
		setCookie("users", "", null)
		E("section").innerHTML = "<div style='margin:auto; width:32px'><img src='loader.gif' align='center' height='32' width='32'/></div>";
		getConfiguration();
	}
	else {
		if (isEmpty(getCookie("users"))) {
			E("section").innerHTML = "<div style='margin:auto; width:32px'><img src='loader.gif' align='center' height='32' width='32'/></div>";
			makeRequest(url, "type=" + getCookie("source"), "getUsers");
		}
		else {
			getUsers(getCookie("users"));
		}
	}
}
function generateUserGrid() {
    editorOn = false;
    var section = E("section");
    while (section.firstChild) {
        section.removeChild(section.firstChild);
    }
    var table = A("table");
    table.id = "qg";
    table.setAttribute("class", "tomato-grid");
    table.setAttribute("cellspacing", "1");

    col = A("col");
    col.setAttribute("width", "10%");
    col.setAttribute("align", "center");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "20%");
    col.setAttribute("align", "left");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "20%");
    col.setAttribute("align", "left");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "20%");
    col.setAttribute("align", "left");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "10%");
    col.setAttribute("align", "center");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "10%");
    col.setAttribute("align", "center");
    table.appendChild(col);

    col = A("col");
    col.setAttribute("width", "10%");
    col.setAttribute("align", "center");
    table.appendChild(col);

    table.appendChild(generateHeader());
    for (var i = 0; i < users.length; i++) {
        table.appendChild(generateTableRow(users[i], (i % 2 == 0) ? "even" : "odd"));
    }
    if(isSourceUsers()){
        table.appendChild(generateEditor(null));
        table.appendChild(generateControls());
    }
    section.appendChild(table);
	div = A("div");
	div.innerHTML = "<div style='float:left'>"+
					"<input style=\"margin: 0 2px; 0 0\" type=\"button\" value='" + dict[lang]["blockSelected"] + "' onclick='blockSelected()' id='blockSelected'/>"
					//+"<!-- <input style=\"margin: 0 0 0 2px;\" type=\"button\" value='" + dict[lang]["sendToSelected"] + "' onclick='sendToSelected()' id='sendToSelected'/> -->
					+"</div>"
	section.appendChild(div);
	restoreState();
}
function makeRequest(url, params, callback)
{
    if (window.XMLHttpRequest){
        http_request = new XMLHttpRequest();
    }
    else
        if (window.ActiveXObject){
            try{
                http_request = new ActiveXObject("Msxml2.XMLHTTP");
            }
            catch (e){
                try{
                    http_request = new ActiveXObject("Microsoft.XMLHTTP");
                }
                catch (e)
                {}
            }
        }
    if (!http_request)
    {
        alert('Giving up :( Cannot create an XMLHTTP instance');
        return false;
    }
    callbackMethod = callback;
	if (E("messages")) {
		E("messages").innerHTML = dict[lang]["saving"];
	}
    http_request.onreadystatechange = function() {
            getResponse(callbackMethod);
    };
    http_request.open('POST', url, true);
    http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    http_request.send(params+ (isEmpty(params)?'' :'&')+ 'v='+callback);
}

function getPages(mac){
	makeRequest(url,"mac="+mac.toUpperCase(),"showPages");
}
function showPages(request){
	request = unescape(request);
    pages = eval(request)[0];
	var user = users[users.find(exampleUser(pages["mac"]))];
	user.hasPages = true;
	user.infoText = unescape(pages["info"]);
	user.msgText = unescape(pages["message"]);
	updateUserCookie();
	E(pages["mac"]+"info").value = unescape(pages["info"]);
	E(pages["mac"]+"msg").value = unescape(pages["message"]);
	E(pages["mac"]+"info").disabled = false;
	E(pages["mac"]+"msg").disabled = false;
}
function removeUser(user) {
    makeRequest(url,'mac='+user.mac.toUpperCase(),"deleteUser");
}
function blockUser(user) {
    makeRequest(url,user.toString(),"block");
}
function manageTimer(){

	var index = E("refresh-time").selectedIndex;
	var timeout = E("refresh-time").options[index].value;
	if (timeout > 0) {
		if (!timerRunning) {
			startTimer();
		}
		else {
			 stopTimer()
		}
	}else{
		disableElement("refresh-button");
		makeRequest(url,"type="+getCookie("source"),"getUsers");
	}
}
function stopTimer(){
	timerRunning = false;
	E("refresh-spinner").style.display = "none";
	E("refresh-time").disabled = "";
	E("refresh-button").value = dict[lang]["refresh-button"];
	clearTimeout(t);
}
function startTimer(){
	timerRunning = true;
	var index = E("refresh-time").selectedIndex;
	var timeout = E("refresh-time").options[index].value;
	t = setTimeout('makeRequest(url,"type='+getCookie("source")+'","getUsers")', timeout*1000);
	E("refresh-spinner").style.display = "inline";
	E("refresh-time").disabled = "disabled";
	E("refresh-button").value = dict[lang]["stop"];	
}
function forward(){
	var address = getCookie("forward");
	if(address.isEmpty()){
		window.location.reload(true);
	}else{
		window.location = address;
		setCookie("forward","",-1);
	}
}
function sendMsg(user) {
	if (/(.*)forward(.*)/.test(user)) {
		E("messages").innerHTML = dict[lang]["saved"];
	}
	else {
		if (!user.delivered) {
			makeRequest(url, user.toString(), "sendMsg");
		}
		else {
			makeRequest("../msg.sh", "mac=" + user.mac.toUpperCase());
		}
	}
}
function addUser(user) {
    makeRequest(url,user.toString(),"addUser");
}
function savePages(user){
	 makeRequest(url,user.toString(),"savePages");
}
function updateUser(user) {
    makeRequest(url,user.toString(),"updateUser");
}
function getSelectedUsers(){
	var selected = new Array();
	for(var i=0;i<users.length;i++){
		if(users[i].selected){
			selected.push(users[i].mac);
		}
	}
	return selected;
}
function blockSelected() {
	var selected = getSelectedUsers();
	if (selected.length > 0) {
		makeRequest(url, "users="+selected.join(","), "blockSelected");
	}
	disableElement("blockSelectedButton");
}

function sendToSelected() {
	var selected = getSelectedUsers();
	if (selected.length > 0) {
		makeRequest(url, selected.join(","), "sendToSelected");
	}
}
function getResponse(callback) {

    if(http_request.readyState == 1){
    }
    if (http_request.readyState == 4)
    {
        if (http_request.status == 200)
        {
			enableElements(disabledElements);
			initConf();
//			translate();
//			populateLanguages()
            if(/(.*)error(.*)/.test(http_request.responseText)){
                E("messages").innerHTML = dict[lang]["error"];
            }else if (/(.*)success(.*)/.test(http_request.responseText)){
                E("messages").innerHTML = dict[lang]["saved"];
				updateUserCookie();
            }else if (/(.*)refresh(.*)/.test(http_request.responseText)){
                makeRequest(url,"type="+getCookie("source"),"getUsers")
                E("messages").innerHTML = dict[lang]["saved"];
            }else if(/(.*)unknown(.*)/.test(http_request.responseText)){
				E("messages").innerHTML = dict[lang]["unknownMethod"];
			}else if(/(.*)forward(.*)/.test(http_request.responseText)){
				E("messages").innerHTML = dict[lang]["saved"];
			}
			else if (callback == undefined) {
				if (/(.*)error(.*)/.test(http_request.responseText)) {
					E("messages").innerHTML = dict[lang]["error"];
				}else if (/(.*)success(.*)/.test(http_request.responseText)) {
					E("messages").innerHTML = dict[lang]["saved"];
				}
            }
            else
            { 
				
	            updateUserCookie();
                eval(callback+"('"+escape(http_request.responseText)+"')");
				E("messages").innerHTML = dict[lang]["saved"];
            }
			setTimeout(function () { if(E("messages")){ E("messages").innerHTML = "" }} ,3000);
        }
        else
        {
            alert(dict[lang]["connectionError"]);
        }
    }
}
function showHideUserPanel(event) {
    if ((!editorOn)) {
		setCookie("state",this.id,null);
        editorOn = true;
        var editedUser = users[users.find(exampleUser(this.id))];//this.user;
        this.parentNode.insertBefore(generateEditor(editedUser), this);
		if (!editedUser.hasPages) {
			E(editedUser.mac+"info").disabled = true;
			E(editedUser.mac+"msg").disabled = true;
			getPages(editedUser.mac);
		}
        this.parentNode.insertBefore(generateEditorControls(editedUser), this);
        this.style.display = "none";		
    }
}
function getConfiguration(request) {
    if (request == undefined) {
			makeRequest(url, "", "getConfiguration");
    }
    else
    {
        request = unescape(request);
        conf = eval(request);
        conf=eval(conf);
        setCookie("source",conf[0]["source"],null);
        setCookie("lang",conf[0]["lang"],365);
        setCookie("userPass",conf[0]["pass"],null);
        setCookie("range",conf[0]["range"],null);
        setCookie("info",conf[0]["info"],null);
        setCookie("message",conf[0]["message"],null);
	setCookie("hasChanged","false",null);
        init();
    }
}
function getUser(row){
	if ((row != null) || (row != undefined)) {
		var dhcpName = row["dhcpName"];
		if(!isEmpty(dhcpName)){
			if (dhcpName == row["name"]) {
				dhcpName="";
			}else{
				dhcpName="("+dhcpName+")";
			}
		}else{
			dhcpName="";
		}
		var user = new User(row["name"]+dhcpName, row["ip"], row["mac"], row["blocked"], row["delivered"], row["online"], false, null, null);
		return user;
	}
	else{
		return null;
	}
}
function generateEditor(user) {

    if (user == null) {
        user = new User("", "", "", false, true, false, false, null, null);
    }
    var editor = A("tr");
    editor.id = user.mac + "editor";
    editor.setAttribute("class", "editor");

    col = A("td");
    col.setAttribute("class", "co0");
    col.setAttribute("align", "center");
    col.innerHTML = "<img src='cross.gif'/>"
    editor.appendChild(col);

    col = A("td");
    col.setAttribute("colspan", "3");
    var table = A("table");
    table.style.width = "100%";

    row = A("tr");
    cell = A("td");
    cell.innerHTML = dict[lang]["name"];
    row.appendChild(cell);
    cell = A("td");
    cell.innerHTML = "<input id='" + user.mac + "name' type='text' maxlength='50' value='" + user.name + "' "+(isSourceUsers() ? "" : "disabled='disabled'")+" />";
    row.appendChild(cell);
    table.appendChild(row);

    row = A("tr");
    cell = A("td");
    cell.innerHTML = dict[lang]["mac"];
    row.appendChild(cell);
    cell = A("td");
    cell.innerHTML = "<input type='text' id='" + user.mac + "mac' maxlength='17' value='" + user.mac + "' "+(isSourceUsers() ? "" : "disabled='disabled'")+" />";
    row.appendChild(cell);
    table.appendChild(row);

    row = A("tr");
    cell = A("td");
    cell.innerHTML = dict[lang]["message"];
    row.appendChild(cell);
    cell = A("td");
    cell.innerHTML = dict[lang]["info"];
    ;
    row.appendChild(cell);
    table.appendChild(row);

    row = A("tr");
    cell = A("td");
    cell.innerHTML = "<textarea class='info' rows='6'  cols='30' id='" + user.mac + "info' >" + (isEmpty(user.infoText) ? "" : unescape(user.infoText)) + "</textarea>";
    row.appendChild(cell);
    cell = A("td");
    cell.innerHTML = "<textarea name='textarea' cols='30' rows='6' class='info' id='" + user.mac + "msg'>" + (isEmpty(user.msgText) ? "" : unescape(user.msgText)) + "</textarea>";
    row.appendChild(cell);
    table.appendChild(row);

    row = A("tr");
	cell = A("td");
	cell.innerHTML = "<input type='button' onclick='show(\""+user.mac+"info\")' value='"+ dict[lang]["preview"]+"'/>"
	row.appendChild(cell);

	cell = A("td");
	cell.innerHTML = "<input type='button' onclick='show(\""+user.mac+"msg\")' value='"+ dict[lang]["preview"] +"'/>"
	row.appendChild(cell);

	table.appendChild(row);

    col.appendChild(table);
    editor.appendChild(col);

    col = A("td");
    col.setAttribute("class", "co2");
    col.setAttribute("align", "center");
    if (user.online)
    {
        image = "tick.gif";
    }
    else
    {
        image = "cross.gif";
    }
    col.innerHTML = "<img src='" + image + "'/>"
    editor.appendChild(col);

    col = A("td");
    col.setAttribute("class", "co3");
    col.setAttribute("align", "center");
    var button = A("input");
    button.setAttribute("type", "button");
	button.id="blockButton";
    button.value = user.blocked ? dict[lang]["unblock"] : dict[lang]["block"];
    button.onclick = function() {

        if (user.blocked) {
            this.parentNode.childNodes[0].removeAttribute("disabled");
        }
        else {
            this.parentNode.childNodes[0].setAttribute("disabled", "true");
        }
        user.blocked = !user.blocked;
        var selection = E(user.mac + "msgType");
        if (selection.selectedIndex == 0) {
            user.isOwnMsg = false;
        }
        else {
            user.isOwnMsg = true;
        }
        this.value = user.blocked ? dict[lang]["unblock"] : dict[lang]["block"];
		disableElement("blockButton");
		disableElement("sendButtton");
		disableElement("blockSelected");
		user.msgText =  E(user.mac+"msg").value;
		user.infoText =  E(user.mac+"info").value;		
        blockUser(user);
    }
    var selection = A("select");
    selection.id = user.mac + "msgType"
    var common = A("option");
    common.innerHTML = dict[lang]["common"];
    selection.appendChild(common);
    var own = A("option");
    own.innerHTML = dict[lang]["own"];
    selection.appendChild(own);
    if (user.blocked) {
        selection.setAttribute("disabled", "true");
    }
    if (user.isOwnMsg) {
        selection.selectedIndex = 1;
    }
    else {
        selection.selectedIndex = 0;
    }

    if (!isEmpty(user.mac)) {
        col.appendChild(selection);
        col.appendChild(button);
    }
    editor.appendChild(col);

    col = A("td");
    col.setAttribute("class", "co4");
    col.setAttribute("align", "center");
    button = A("input");
	button.id="sendButtton"
    button.setAttribute("type", "button");
    button.value = user.delivered ? dict[lang]["send"] : dict[lang]["cancel"];
    button.onclick = function() {
        user.delivered = ! user.delivered;
        this.value = user.delivered ? dict[lang]["send"] : dict[lang]["cancel"];
		disableElement("blockButton");
		disableElement("sendButtton");
		disableElement("blockSelected");
		user.msgText =  E(user.mac+"msg").value;
		user.infoText =  E(user.mac+"info").value;		
        sendMsg(user);
    }
    if (!isEmpty(user.mac)) {
        col.appendChild(button);
    }
    editor.appendChild(col);

    return editor;

}
function generateTableRow(user, style) {

    var element = A("tr");
    element.id = user.mac;
    element.setAttribute("class", style);

    cell = A("td")
    cell.setAttribute("align", "center");
    var clazz = "notSelected";
    if (user.selected) {
        clazz = 'selected';
    }
    cell.innerHTML = "<img align='top' src='clear.gif' name='select' id='select" + user.mac + "' class='" + clazz + "' height='16' width='16' onclick='selectOne(event,this)'/>"//"<input type='checkbox' name='select' id='"+ user.mac +"'/>";
	
    element.appendChild(cell);
    cell = A("td")
    cell.setAttribute("align", "left");
    cell.innerHTML = user.mac;
    element.appendChild(cell);

    cell = A("td")
    cell.setAttribute("align", "left");
    cell.innerHTML = user.ip;
    element.appendChild(cell);

    cell = A("td")
    cell.setAttribute("align", "left");
    cell.innerHTML = user.name;
    element.appendChild(cell);

    if (user.online)
    {
        image = "tick.gif";
    }
    else
    {
        image = "cross.gif";
    }
    cell = A("td")
    cell.setAttribute("align", "center");
    cell.innerHTML = "<img src='" + image + "'/>";
    element.appendChild(cell);
    if (user.blocked)
    {
        image = "tick.gif";
    }
    else
    {
        image = "cross.gif";
    }
    cell = A("td")
    cell.innerHTML = "<img src='" + image + "'/>";
    cell.setAttribute("align", "center");
    element.appendChild(cell);
    cell = A("td");
    cell.setAttribute("align", "center");
    cell.innerHTML = user.delivered ? dict[lang]["delivered"] : dict[lang]["undelivered"];
    element.appendChild(cell);
    element.onclick = showHideUserPanel;

    return element;
}
function generateHeader() {

    element = A("tr");
    element.setAttribute("class", "header");

    column = A("td");
    column.setAttribute("align","center");
    column.innerHTML = "<img align='top' src='clear.gif' class='notSelected' height='16' width='16' onclick='selectAll(this)'/>";
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co1 " + sort[0]);
    column.setAttribute("style", "width:20%");
    column.innerHTML = dict[lang]["mac"];
    column.onclick = function () {
        sortGrid(cmpMac, sort[0] == "sortasc" ? false : true);
    }
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co1 " + sort[1]);
    column.setAttribute("style", "width:20%")
    column.innerHTML = dict[lang]["ip"];
    column.onclick = function () {
        sortGrid(cmpIP, sort[1] == "sortasc" ? false : true);
    }
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co1 " + sort[2]);
    column.setAttribute("style", "width:20%")
    column.innerHTML = dict[lang]["user"];
    column.onclick = function () {
        sortGrid(cmpName, sort[2] == "sortasc" ? false : true);
    }
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co2");
    column.setAttribute("style", "width:10%");
    column.innerHTML = dict[lang]["online"];
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co3");
    column.setAttribute("style", "width:10%");
    column.innerHTML = dict[lang]["blocked"];
    element.appendChild(column);

    column = A("td");
    column.setAttribute("class", "co4");
    column.setAttribute("style", "width:10%");
    column.innerHTML = dict[lang]["info"];
    element.appendChild(column);

    return element;
}
function selectAll(elem) {
    var clazz = "";
    var sel;
    if (elem.className == "selected") {
        clazz = "notSelected";
        sel = false;
    } else {
        clazz = "selected";
        sel = true;
    }
    var elems = document.getElementsByName("select");
    elem.className = clazz;
    for (var i = 0; i < elems.length; i++) {
        elems[i].className = clazz;
		users[users.find(exampleUser(elems[i].parentNode.parentNode.id))].selected = sel;
    }
}
function selectOne(event, elem) {
    event.cancelBubble = true;
    if (elem.className == "selected") {
        elem.className = "notSelected";
		users[users.find(exampleUser(elems.parentNode.parentNode.id))].selected = false;
    } else {
        elem.className = "selected";
       		users[users.find(exampleUser(elem.parentNode.parentNode.id))].selected = true;
    }
}
function cmpName(a, b) {
    if (a.name > b.name) {
        return 1;
    } else if (a.name < b.name) {
        return -1;
    }
    else {
        return 0;
    }
}
function cmpMac(a, b) {
    if (a.mac > b.mac) {
        return 1
    } else if (a.mac < b.mac) {
        return  -1;
    }
    else {
        return  0;
    }
}
function cmpIP(a, b) {
    ia = a.ip.split(".");
    ib = b.ip.split(".");
	if(ia.length!=4){
		ia=["0","0","0","0"];
	}
	if(ib.length!=4){
		ib=["0","0","0","0"];
	}
    for (var i = 0; i < 4; i++) {
        if ((parseInt(ia[i]) - parseInt(ib[i])) != 0) {
            return parseInt(ia[i]) - parseInt(ib[i]);
        }
    }
    return 0;
}
function sortGrid(fun, asc) {

    if (editorOn)
        return;
    if (fun == cmpIP) {
        sort[0] = "";
        sort[1] = asc ? "sortasc" : "sortdes";
        sort[2] = "";
    } else if (fun == cmpMac) {
        sort[0] = asc ? "sortasc" : "sortdes";
        sort[1] = "";
        sort[2] = "";
    } else if (fun == cmpName) {
        sort[0] = "";
        sort[1] = "";
        sort[2] = asc ? "sortasc" : "sortdes";
    }

    users.sort(fun);
    if (!asc) {
        users.reverse();
    }
    generateUserGrid();
}
function generateControls() {

    element = A("tr");
    element.setAttribute("class", "controls");
    element.id = "controls";

    column = A("td");
    column.setAttribute("colspan", "7");
    var button = A("input");
    button.setAttribute("type", "button");
    button.value = dict[lang]["add"];
    button.onclick = function () {
        editor = E("editor");
        var name = E("name").value;
        var mac = E("mac").value;
        var match = /^([0-9A-F]{2}:){5}[0-9A-F]{2}$/.test(mac.toUpperCase());
        error = "";
        if ((name == "") || (name == null)) {
            error += dict[lang]["emptyName"];
        }
        if (!match) {
            error += "\n\n" + dict[lang]["wrongMac"];
        }
        if (error != "") {
            alert(error);
            return;
        }
        else {
			var msg = E("msg").value;
			var info = E("info").value;
            user = new User(name, "", mac, false, true, false, false, msg, info);
            if(users.find(user)<0){
                users.push(user);
                generateUserGrid();
                addUser(user);
            }else{
                alert(dict[lang]["userExists"]);
            }
        }
    }
    column.appendChild(button);
    element.appendChild(column);
    return element;
}
function generateEditorControls(user) {
    element = A("tr");
    element.setAttribute("class", "controls");
    element.id = user.mac + "controls";

    column = A("td");
    column.setAttribute("colspan", "7");
    column.setAttribute("align", "right");

    var button = A("input");
    button.setAttribute("type", "button");
    button.value = dict[lang]["delete"];
    button.onclick = function() {
        removeUser(user);
        users.remove(user);
        generateUserGrid();
    };
    if(isSourceUsers()){
        column.appendChild(button);
    }
    button = A("input");
    button.setAttribute("type", "button");
    button.value = dict[lang]["ok"];
    button.onclick = function () {
        var newName = E(user.mac + "name").value;
        var newMac = E(user.mac + "mac").value;
        var error = "";
		if(!isSourceUsers()){
			newMac = user.mac;
			newName = user.name;
		}
        var match = /^([0-9A-F]{2}:){5}[0-9A-F]{2}$/.test(newMac.toUpperCase());
        //sth has changed - mac or name, so we want to save it;
        var newInfoText = E(user.mac + "info").value.replace(/;/g, ",");
        var newMsgText = E(user.mac + "msg").value.replace(/;/g, ",");
		if (newInfoText=="") newInfoText=null;
		if (newMsgText=="") newMsgText=null;
        if ((newName != user.name) || (newMac != user.mac) || (newInfoText != user.infoText) || (newMsgText != user.msgText)) {
            if (isEmpty(newName) && isSourceUsers()) {
                error += dict[lang]["emptyName"];
            }
            if (!match) {
                error += "\n\n" + dict[lang]["wrongMac"];
            }
            if (error != "") {
					alert(error);
					return;
            }
            //no errors
            else {
                user.name = newName;
                user.mac = newMac;
                user.infoText = (newInfoText == null) ? "" : newInfoText.replace(/;/g, ",").replace(/\r\n/g," ");
                user.msgText = (newMsgText == null) ? "" : newMsgText.replace(/;/g, ",").replace(/\r\n/g," ");
				if (isSourceUsers()) {
					updateUser(user);
				}else{
					savePages(user);
				}
            }
        }
        else {
            if (editorOn) {
				setCookie("state","",null);
                editorOn = false;
                table = E("qg");
                E(user.mac).style.display = "table-row";
                table.removeChild(this.parentNode.parentNode);
                table.removeChild(E(user.mac + "editor"));
                generateUserGrid();
            }
        }
    };
    column.appendChild(button);
    button = A("input");
    button.setAttribute("type", "button");
    button.value = dict[lang]["cancel"];
    button.onclick = function () {
        if (editorOn) {
			setCookie("state","",null);
            editorOn = false;
            table = E("qg");
            E(user.mac).style.display = "table-row";
            table.removeChild(this.parentNode.parentNode);
            table.removeChild(E(user.mac + "editor"));
            generateUserGrid();
        }

    };
    column.appendChild(button);
    element.appendChild(column);
    return element;
}
/*
function generateNaviPanel() {

    var navi = A("td");
    navi.id = "navi";

    settings = A("a");
    settings.setAttribute("href", "settings.sh");
    settings.setAttribute("class", "indent1");
    settings.value = dict[lang]["settings"];
    navi.appendChild(settings);
    about = A("a");
    about.setAttribute("href", "about.sh");
    about.setAttribute("class", "indent1important");
    about.value = dict[lang]["about"];
    navi.appendChild(about);
    return navi;
}
*/
function restoreState(){
	var status = getCookie("state");
	if(!status.isEmpty()){
		row = E(status);
		if (row) {
			row.click();
		}
	}
}
function initConf(){
	lang = isEmpty(getCookie("lang")) ? "pl" : getCookie("lang");
	translate();
	populateLanguages();
    //setting lang
	if (E("lang")) {
		opts = E("lang");
		for (i = 0; i < opts.options.length; i++) {
			if (opts.options[i].value.toUpperCase() == getCookie("lang").toUpperCase()) {
				opts.selectedIndex = i;
				//lang=conf["lang"];
				break;
			}
		}
		//setting source
		opts = document.getElementsByName("source");
		for (i = 0; i < opts.length; i++) {
			if (opts[i].value == getCookie("source")) {
				opts[i].checked = true;
				break;
			}
		}
		range = getCookie("range");
		E("portFrom").value = range.split(":")[0];
		E("portTo").value = range.split(":")[1];
		E("message").value = getCookie("message");
		E("info").value = getCookie("info");
		E("userPass").value = getCookie("userPass");
	}
}
function saveConfiguration(conf){
	if (conf["message"] == getCookie("message")) {
		conf["message"] = null;
	}
	else {
		conf["message"] = conf["message"].replace(/;/g, ",").replace(/\r\n/g," ")
		setCookie("message", conf["message"], null);
	}
	if (conf["info"] == getCookie("info")) {
		conf["info"] = null;
	}
	else {
		conf["info"] = conf["info"].replace(/;/g, ",").replace(/\r\n/g," ")
		setCookie("info", conf["info"], null);
	}
	if (conf["range"] == getCookie("range")) {
		conf["range"] = null;
	}
	else {
		setCookie("range",conf["range"],null);
	}
	if (conf["userPass"] == getCookie("userPass")) {
		conf["userPass"] = null;
	}
	else {
		setCookie("userPass", conf["userPass"], null);
	}
	
	if (conf["lang"] == getCookie("lang")) {
		conf["lang"] = null;
	}
	else {
		setCookie("lang", conf["lang"], 365);
		lang = conf["lang"];
	}
	if (conf["source"] == getCookie("source")) {
		conf["source"] = null;
	}
	else {
		setCookie("source", conf["source"], null);
		setCookie("hasChanged","true",null);
	}
	makeRequest(url,"lang="+conf["lang"]+"&source="+conf["source"]+"&range="+conf["range"]+"&info="+conf["info"]+"&pass="+conf["userPass"]+"&message="+conf["message"],"saveConf");
}
function translate(){
	var buttons = document.getElementsByTagName("input");
	
	for (var j in buttons) {
		if (buttons[j].type) {
			if (buttons[j].type.toUpperCase() == "BUTTON") {
				var label = dict[lang][buttons[j].name]
				buttons[j].value = isEmpty(label) ? buttons[j].value : label;
			}
		}
	}
	for (var i in dict[lang]) {
		if (E(i)) {
			var elem = E(i);
			if (elem.tagName.toUpperCase() != "INPUT") {
				elem.innerHTML = dict[lang][i];
			}
		}
	}
}
function populateLanguages(){
	var select = E("lang");
	if (select) {
		for (var i in dict) {
			if (typeof(dict[lang][i]) == "string") {
				var opt = new Option();
				opt.value = i;
				opt.text = dict[lang][i];
				select.add(opt, null);
			}
		}
	}
}

function isEmpty(str) {
    if (str == null) {
        return true;
    }
    if(str.length == 0){
        return true;
    }
	if(str == undefined){
		return true;
	}
    if(typeof(str) == "string"){
        var trimmed = str.replace(/^w+/, "").replace(/w+$/, "");
        if (trimmed.length > 0)
        {
            return false;
        }
        else {
            return true;
        }
    }
    else{
        return true;
    }
}
function A(id){
	return document.createElement(id);
}

function E(id) {
    return document.getElementById(id);
}
function setCookie(c_name, value, expiredays)
{
    var exdate = new Date();
	exdate.setTime(exdate.getTime()+(expiredays*24*60*60*1000));
	var cookie = escape(value);
	if(!isEmpty(getSingleCookie(c_name + "_parts"))) {
		var parts = eval(getCookie(c_name + "_parts"));
		setCookie(c_name + "_parts","",-1);
		for(var i=0;i<parts;i++){
			setCookie(c_name+"_"+i,"",-1);
		}
	}
	if (cookie.length > 4000) {
		var cookieArray = new Array();
		var start = 0;
		while (cookie.length > 4000) {
			cookieArray.push(cookie.substr(start, 4000));
			start += 4000;
			cookie = cookie.substr(start, cookie.length - start);
		}
		cookieArray.push(cookie);
		for(var i=0;i<cookieArray.length;i++){
			document.cookie = c_name+"_"+i + "=" + cookieArray[i] +
				((expiredays == null) ? "" : ";expires=" + exdate.toGMTString())+"; path=/";
		}
		document.cookie = c_name+"_parts" + "=" + cookieArray.length +
			((expiredays == null) ? "" : ";expires=" + exdate.toGMTString())+"; path=/";
		
		if(!isEmpty(getSingleCookie(c_name))){
			setCookie(c_name,"",-1);
		}
	}
	else {
		document.cookie = c_name + "=" + cookie +
		((expiredays == null) ? "" : ";expires=" + exdate.toGMTString())+"; path=/";
	}
}
function updateUserCookie(){
	if ((users != undefined)&&(users != null)) {
		setCookie("users", JSON.stringify(users), null);
	}
}
function getCookie(c_name)
{
    if (document.cookie.length > 0)
    {
		var parts = getSingleCookie(c_name+"_parts")
		if(!isEmpty(parts)){
			var cookieArray = new Array();
			for(var i=0;i<eval(parts);i++){
				cookieArray[i]=getSingleCookie(c_name+"_"+i);
			}
			return cookieArray.join();
		}
		else{
			return getSingleCookie(c_name);
		}
    }
    return "";
}

function getSingleCookie(c_name){
	if (document.cookie.length > 0)
    {
        c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1)
        {
            c_start = c_start + c_name.length + 1;
            c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1) c_end = document.cookie.length;
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}
function isSourceUsers(){
    if(getCookie("source")=="users")
        return true;
    else return false;
}
function fixPort(p, def)
{
    if (def == null) def = -1;
    if (p == null) return def;
    p *= 1;
    if ((isNaN(p)) || (p < 1) || (p > 65535)) return def;
    return p;
}
function disableElement(id){
	if (E(id)) {
		E(id).disabled = true;
		disabledElements.push(id);
	}
}
function enableElements(){
	
	while(disabledElements.length>0){
		E(disabledElements.pop()).disabled="";		
	}
}
function preview(win,msg){
		var doc = win.document;
		doc.open('text/html;charset=UTF-8');
		doc.write(
		'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">' +
		'<html id="popup">' +
		'<head><title>' + dict[lang]["preview"] + '</title>' +
		'<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">' +
		'<meta http-equiv="imagetoolbar" content="false">' +
		'<link rel="stylesheet" href="../tomato.css">' +
		'</head><body onclick="window.close();">'+
		'<div class="message" id="message">'+
		msg.replace(/\.\/pages/g, "../pages") +
		'</div>'
		+'</body></html>'
		);
		doc.close();
}
function show(id){
	var winopts = "dependent=yes,toolbar=no,resizable=yes,width=800,height=600";
	var win = window.open(this.href,'_blank',winopts);
	preview(win,E(id).value.replace(/,/g, ";"));
}	
function hasChanged(){
	return getCookie("hasChanged") != "false";
	}
